/*-*-C-*-
 * Copyright 2006  Petter Urkedal
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This file is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <cuex/binding.h>
#include <cuex/oprdefs.h>
#include <cuex/opn.h>

cuex_t
cuexP_bfree_adjusted(cuex_t e, int l_diff, int l_top)
{
    cuex_meta_t e_meta = cuex_meta(e);
    if (cuex_meta_is_opr(e_meta)) {
	if (cuex_oa_mubind(e_meta))
	    ++l_top;
	CUEX_OPN_TRAN(e_meta, e, ep, cuexP_bfree_adjusted(ep, l_diff, l_top));
    }
    else if (cuex_is_rvarmeta(e_meta)) {
	int l = cuex_varmeta_index(e_meta);
	if (l > l_top)
	    return cuex_rvar(l + l_diff);
    }
    return e;
}
