/*-*-C-*-
 * Copyright 2006  Petter Urkedal
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This file is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <cuex/recursion.h>
#include <cuex/ex.h>
#include <cuex/oprdefs.h>
#include <cuex/opn.h>
#include <cuex/var.h>

static cuex_t
mu_unfold(cuex_t e, int l_top, cuex_t e_top)
{
    cuex_meta_t e_meta = cuex_meta(e);
    if (cuex_meta_is_opr(e_meta)) {
	if (cuex_oa_mubind(e_meta))
	    ++l_top;
	CUEX_OPN_TRAN(e_meta, e, ep, mu_unfold(ep, l_top, e_top));
    }
    else if (cuex_is_rvarmeta(e_meta)) {
	int l = cuex_varmeta_index(e_meta);
	if (l == l_top)
	    return cuex_bfree_adjusted(e_top, l_top);
	else if (l > l_top)
	    return cuex_rvar(l - 1);
    }
    return e;
}

cuex_t
cuex_mu_unfold(cuex_t e)
{
    cuex_meta_t e_meta = cuex_meta(e);
    cu_debug_assert(cuex_meta_is_opr(e_meta) && cuex_oa_mubind(e_meta));
    e_meta = cuex_oa_mubind_set(e_meta, 0);
    CUEX_OPN_TRAN(e_meta, e, ep, mu_unfold(ep, 0, e));
    return e;
}
