#include <cuflow/cache.h>
#include <cuflow/cache_b0_tab.h>
#include <cuflow/time.h>

cuflow_cached_edcl(fn1,
    ( int i; ),
    ( int j; ));

cuflow_cached_edef(fn1)
{
    fn1_obj_t obj = cuflow_cached_new(fn1, 0);
    obj->j = key->i;
    cuflow_cacheobj_set_gain((cuflow_cacheobj_t)obj, 1.0);
    return obj;
}

#define CALL_CNT 1000000

void test()
{
    int i;
    clock_t t = -clock();
    for (i = 0; i < CALL_CNT; ++i) {
	struct fn1_key_s key;
	fn1_obj_t obj;
	key.i = i;
	obj = testcache_call(fn1, &key);
    }
    t += clock();
    printf("%lg s per uncached call\n", t/((double)CLOCKS_PER_SEC*CALL_CNT));
    t = -clock();
    for (i = 0; i < CALL_CNT; ++i) {
	struct fn1_key_s key;
	fn1_obj_t obj;
	key.i = 0;
	obj = testcache_call(fn1, &key);
    }
    t += clock();
    printf("%lg s per cached call\n", t/((double)CLOCKS_PER_SEC*CALL_CNT));
}

int main()
{
    cuflow_init();
    testcache_init(cuflow_default_cacheconf());
    test();
    return 0;
}
